<?php

$geobrowser_path = drupal_get_path('module', 'geobrowser');

//Load Geobrowser Map node
if (!$nid){
	$nid = $_GET['nid'];
}
$node = node_load($nid);

// Set user input overrides
if ($_GET['start_lat']) $start_lat = $_GET['start_lat'];
	else $start_lat = $node->start_lat;
	
if ($_GET['start_lon']) $start_lon = $_GET['start_lon'];
	else $start_lon = $node->start_lon;

if ($_GET['start_zoom']) $start_zoom = $_GET['start_zoom'];
	else $start_zoom = $node->start_zoom;
	
if ($_GET['initial_page']) $initial_page = $_GET['initial_page'];
	else $initial_page = $node->initial_page;

if ($_GET['initial_tree']) $initial_tree = $_GET['initial_tree'];
	else $initial_tree = 0;


	function geobrowser_intial_info_window_path($initial_page){
		if ($initial_page == "<none>") return $geobrowser_path."/loading.html";
		else return(base_path().'?q='.$initial_page);
	}

  function geobrowser_java_vocab_titles($node){
	$vocabs = $node->vocabs;
	
    
	  $output = "var vocab_titles = new Array(); ";
	  foreach ($vocabs as $vocab_id) {
			if ($vocab_id){
		    $get_vid_titles = db_query("SELECT name from {vocabulary} where vid = " . $vocab_id);
		    $title = db_result($get_vid_titles,0,"name");
		    $output .= "vocab_titles[$vocab_id] = '$title'; ";
		  }
	  }
    
    $i=0;
    foreach ($vocabs as $vocab_id) {
      $output .= "document.getElementById('tree_holder').innerHTML += \"<div id='tree_menu$i' style='display:none;'></div>\"; ";
      $i++;
    }
    
    $i=0;
    foreach ($vocabs as $vocab_id) {
      $output .= "build_tree($i); ";
      $output .= "vid_to_tree[".$vocab_id."] = ".$i.";";
      $i++;
      
    }
     
  return $output;
  }
  
  function geobrowser_base_maps($node){
    $output = 'map.getMapTypes().length = 0; META_TILING = true;';
    $default_map;
    $base_map_results = db_query("select * from {geobrowser_basemap_link} INNER JOIN {geobrowser_basemaps} ON {geobrowser_basemaps}.id = {geobrowser_basemap_link}.base_id WHERE nid = %d", $node->nid);
    while ($base_map = db_fetch_object($base_map_results)) {
      if ($base_map->id == 1) $output.= "map.addMapType(G_NORMAL_MAP);";
      if ($base_map->id == 2) $output.= "map.addMapType(G_SATELLITE_MAP);";
      if ($base_map->id == 3) $output.= "map.addMapType(G_HYBRID_MAP);";
      
      if ($base_map->id >= 4) {
        if ($base_map->type == "WMS"){
	        $output .= "
	          var layerconfig".$base_map->id." = new GTileLayer(new GCopyrightCollection(''),1,17);
	          layerconfig".$base_map->id.".myLayers='".$base_map->layer."';
	          layerconfig".$base_map->id.".myBaseURL='".$base_map->address."';
	          layerconfig".$base_map->id.".getTileUrl=CustomGetTileUrl;
	          layerconfig".$base_map->id.".myOpacity=".$base_map->opacy.";
	          layerconfig".$base_map->id.".getOpacity=customOpacity;
	          var layer".$base_map->id."=[G_SATELLITE_MAP.getTileLayers()[0],layerconfig".$base_map->id."];
	          var custommap".$base_map->id." = new GMapType(layer".$base_map->id.", G_SATELLITE_MAP.getProjection(), '".$base_map->display_name."', G_SATELLITE_MAP);
	          map.addMapType(custommap".$base_map->id.");
	        ";
      	}
      	if ($base_map->type == "tilecache"){
      	  $output .= "
      	  	var copyCollection".$base_map->id." = new GCopyrightCollection('Chart');
						var copyright".$base_map->id." = new GCopyright(1, new GLatLngBounds(new GLatLng(-90, -180), new GLatLng(90, 180)), 0, '');
						copyCollection".$base_map->id.".addCopyright(copyright".$base_map->id.");

						var tilelayer".$base_map->id." = [new GTileLayer(copyCollection".$base_map->id.", ".$base_map->tile_min.", ".$base_map->tile_max.")];
						tilelayer".$base_map->id."[0].getTileUrl = CustomGetTileUrl".$base_map->id.";

						function CustomGetTileUrl".$base_map->id."(a,b) {
							return '".$base_map->tile_path."'+b+'_'+a.x+'_'+a.y+'.png';
						}

						var custommap".$base_map->id." = new GMapType(tilelayer".$base_map->id.", new GMercatorProjection(".($base_map->tile_max + 1)."), 
						'".$base_map->display_name."'); map.addMapType(custommap".$base_map->id.");

      		";
            	} }

      $default_map = $base_map->id;
       } $output .= "map.setCenter(new 
						GLatLng(begin_lat,begin_lon), begin_zoom);"; if ($default_map == 1) 
						$output.= "map.setMapType(G_NORMAL_MAP);"; if ($default_map == 2) 
						$output.= "map.setMapType(G_SATELLITE_MAP);"; if ($default_map == 3) 
						$output.= "map.setMapType(G_HYBRID_MAP);"; if ($default_map >= 4) 
						$output.= "map.setMapType(custommap".$default_map.");"; return 
						$output; }

  function geobrowser_certain_cats($node){
  	$output = "function certain_cats(){";
    foreach ($node->vocabs as $vid){
			if (array_key_exists('vid'.$vid, $_GET)){
				if ($_GET['vid'.$vid] == '0') $output .= "uncheck_tree(vid_to_tree[".$vid."]);";
				else $output .= "check_categories('".$_GET['vid'.$vid]."', vid_to_tree[".$vid."]);";
			}
  	}
  	
  	$i=0;
  	foreach ($node->vocabs as $vid){
			if (array_key_exists('layer'.$i, $_GET)){
				if ($_GET['layer'.$i] == '0') $output .= "uncheck_tree(vid_to_tree[".$i."]);";
				else $output .= "check_categories('".$_GET['layer'.$i]."', ".$i.");";
			}
			$i++;
  	}
  	
  	$output .= "}";
  	return $output;
  }

  function geobrowser_additional_css(){
    	$output = ""; if 
						($_GET['additional_css']){ $additional_css_array = 
						explode(",",$_GET['additional_css']); foreach ($additional_css_array 
						as $additional_css){ $output .= "<link rel='STYLESHEET' 
						type='text/css' href='".drupal_get_path('module', 
						'geobrowser')."/".$additional_css."'/>"; } return $output;
}
}

?>



<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
  <title><?php print($node->title); ?></title>

  <!-- Loading scripts for our side check-box menu -->
  <script src="<?php print $geobrowser_path; ?>/controls/tree/js/dhtmlXCommon.js" type="text/javascript"></script>
  <script src="<?php print $geobrowser_path; ?>/controls/tree/js/dhtmlXTree.js" type="text/javascript"></script>
  <script src="<?php print $geobrowser_path; ?>/browser.js" type="text/javascript"></script>
  <script src="<?php print $geobrowser_path; ?>/wms-gs.js" type="text/javascript"></script>
  <link rel="STYLESHEET" type="text/css" href="<?php print $geobrowser_path; ?>/controls/tree/css/dhtmlXTree.css"/>
  <link rel="STYLESHEET" type="text/css" href="<?php print $geobrowser_path; ?>/tabs.css"/>
  <link rel="STYLESHEET" type="text/css" href="<?php print $geobrowser_path; ?>/geobrowser.css"/>
	<?php print geobrowser_additional_css(); ?>
  <!--[if IE 6]><style type="text/css">.sidebar { background-color:white } </style><![endif]-->
  
  <!-- Script for managing page layout -->
  <script type="text/javascript">
  window.onresize = resize_layout;
  function resize_layout(){
        document.getElementById('map').style.height = ((document.documentElement.clientHeight))+ 'px';
        document.getElementById('info_window').style.height = ((document.documentElement.clientHeight) * .99)+ 'px';
  };
  </script>
  
	<!-- Loading the google map core -->
	<script src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=<?php print(variable_get('geobrowser_gmap_key','')); ?>" type="text/javascript"></script>
	<script src="<?php print $geobrowser_path; ?>/controls/googleMapTooltips.js" type="text/javascript"></script>

</head>

<body onunload="GUnload()">

    <div id="control_div">
    <img id="view-refresh" src="<?php print $geobrowser_path; ?>/img/view-refresh.png" onclick="map_redraw();" onmouseover="set_message(refresh_text)" onmouseout="set_message()" alt="Refresh View"/>
    <img id="zoom-out" src="<?php print $geobrowser_path; ?>/img/zoom-out.png" onclick="map.zoomOut();" onmouseover="set_message(zoom_out_text)" onmouseout="set_message()" alt="Zoom Out"/>
    <img id="zoom-in" src="<?php print $geobrowser_path; ?>/img/zoom-in.png" onclick="map.zoomIn();" onmouseover="set_message(zoom_in_text)" onmouseout="set_message()" alt="Zoom In"/>
    </div>
    
<!-- Our Main Map Window -->
<div id="map"></div>

<a href="#" onClick="top.location='<?php print(base_path()); ?>?q=geobrowser/<?php print($node->nid); ?>&initial_page=<none>&start_lat='+map.getCenter().lat()+'&start_lon='+map.getCenter().lng()+'&start_zoom='+map.getZoom() + '&initial_tree=' + current_tree + get_layer_string();">
<div id='view_fullscreen' style='padding-left:3px; border:1px solid grey; background-color:white; width:100px; position:absolute; top:0px; right:0px; z-index:1; display:none;'>
	<?php print(t('Full Screen')); ?>
	<img src='<?php print($geobrowser_path); ?>/img/fullscreen.png' style='position:absolute;top:0px;right:0px;border:none;'>
</div>
</a>

<div id="sidebar-background" class="sidebar"></div>
<div class="sidebar" id="sidebar-foreground">
  <h2 id="geobrowser_title"><?php print($node->title); ?></h2>
  <?php print check_markup($node->top_html, $node->top_filter, FALSE); ?>
  
  <!-- Our Layer / Feature Tree -->
  <div id="tabsF">
  	<ul id="tabnav">
  	</ul>
  <div style="with:100%; border-bottom:1px solid #666;"></div>
  </div>
  
  <div id='tree_holder'>
  </div>
  
  <div id="message_center"></div>
  <div style="position:absolute; bottom:2px; margin-left: 5px;">
  	<?php print check_markup($node->bottom_html, $node->bottom_filter, FALSE); ?>
	</div>
</div>

<div id="info_window" style="<?php if ($initial_page == '<none>') print(' display:none; '); ?>">
<img src="<?php print $geobrowser_path; ?>/img/close.png" id="close_button" onClick="hidediv('info_window')"/>
  <iframe id="info_frame" name="info_frame_name" src="<?php print geobrowser_intial_info_window_path($initial_page); ?>"></iframe>
</div>

<script  type="text/javascript">resize_layout();</script>

<!-- Our Main Script -->
<script type="text/javascript">
//<![CDATA[
  

  //Set-up our global variables
  var marker_set = new Array();    //load up our array of marker data
  var marker_icons = new Array();  //load up all our marker icons to be displayed on the map.
  var new_marker_mode = false;
  var new_marler_node_type;
  var tree = new Array();
  var vid_to_tree = new Array();
  var view_lat_min;
  var view_lat_max;
  var view_lon_min;
  var view_lon_max;
  var start_lat_min;
  var start_lat_max;
  var start_lon_min;
  var start_lon_max;
  var current_tree = 0;
  var map_nid = <?php print($node->nid); ?>;
  var base_path = "<?php print(base_path()); ?>";
  var files_path = "<?php print(file_directory_path()); ?>";
  var icon_height = "<?php print(variable_get('taxonomy_image_height',18)); ?>";
  var icon_width = "<?php print(variable_get('taxonomy_image_width',18)); ?>";
  var gmap_key = "<?php print(variable_get('geobrowser_gmap_key','')); ?>";
  var begin_lat = "<?php print($start_lat); ?>";
  var begin_lon = "<?php print($start_lon); ?>";
  var begin_zoom = <?php print($start_zoom); ?>;
  var zoom_in_text = "<?php print(t('Zoom In')); ?>";
  var zoom_out_text = "<?php print(t('Zoom Out')); ?>";
  var refresh_text = "<?php print(t('Reload Markers')); ?>";
  var add_marker_text = "<?php print(t('Click on the map to add a new marker')); ?>";
  var draggable_markers = <?php if ($node->draggable == 1) print 'true'; else print 'false'; ?>; 
  var geobrowser_path = "<?php print $geobrowser_path; ?>";
  var initial_tree = "<?php print $initial_tree; ?>";
  //Set-up our global vocabulary variables
  
  var vocabs = new Array();
  
  <?php
    $vocabs = $node->vocabs;
    $i=0;
    foreach($vocabs as $vocab_id){
    	print ("vocabs[$i] = ".$vocab_id."; ");
    	$i++;
    }
    
    print("var vocab_vid = '");
    foreach($vocabs as $vocab_id){
    	print ($vocab_id.",");
    }
    print("';");
  ?>
  
  //Initialize the whole shibang
  
  <?php print geobrowser_certain_cats($node); ?>
  
  <?php print geobrowser_java_vocab_titles($node); ?>
  
  //Load up our google map
  var map = new GMap2(document.getElementById("map"));
  <?php print geobrowser_base_maps($node); ?>
  
  map.addControl(new GMapTypeControl( ),new GControlPosition(G_ANCHOR_TOP_LEFT,new GSize(7,7)));
  framed_adjustments();
  
  // ====== set up marker mouseover tooltip div ======
  var tooltip = document.createElement("div");
  tooltip.setAttribute('id','tooltip');
  map.getPane(G_MAP_FLOAT_PANE).appendChild(tooltip);

  
  //Add all our event listeners for the map
  GEvent.addListener(map, "click", node_clicked);
  GEvent.addListener(map, "moveend", map_load_markers);  // listning for the user panning. Triggers the map_moved function
  GEvent.addListener(map, "zoomend", map_zoomed); // map is redrawn on a zoom
//]]>
</script>

</body>
</html>